<?php

include './core.php';

checkAuth("CA");

cabecera (4);

$command = $_POST['command'];
$errorCode = "a0";

switch ($command) {

   default:

      $dirBase = $dirVar['crl'];
      $date = "crl_d".date('dmY')."t".date('His');

      echo "<h1 class='title'>Generaci&oacute;n de Lista de Certificados Revocados</h1>

      <form method='post' action='' enctype='multipart/form-data' name='csr_chk_pin'>
      <div id='tbox'>
        <h3 class='head_a2b1'>Generaci&oacute;n CRL</h3>
        <div id='tbox_data_a1'>
          <div id='trow'>
            <div id='tname'>Pass Phrase:</div>
            <div id='tvalue'><input type='password' name='pass_phrase' size='25' /></div>
          </div>
          <div id='trow'>
            <div id='tvalue'>
              <input class='button' type='submit' value='Generar CRL' />
            </div>
          </div>
        </div>
      </div>
      <input type='hidden' name='command' value='gen_crl' />

      </form>\n";

      break;

   case "gen_crl":
      $pass_phrase = $_POST['pass_phrase'];

      $dirBase = $dirVar['crl'];
      $date = "crl_d".date('dmY')."t".date('His');
      $anioCrl = substr($date, 9,4);
      $mesCrl = substr($date, 7, 2);
      $diaCrl = substr($date, 5, 2);
 
      if (!is_dir($dirBase . $anioCrl)) {
         $dirBase = $dirBase . $anioCrl ."/";
         mkdir($dirBase, 0764);
      }
      else 
         $dirBase = $dirBase . $anioCrl ."/";
      
      if (!is_dir($dirBase . $anioCrl . $mesCrl)) {
         $dirBase = $dirBase . $anioCrl . $mesCrl . "/";
         mkdir($dirBase, 0764);
      }
      else 
         $dirBase = $dirBase . $anioCrl . $mesCrl . "/";
      
      if (!is_dir($dirBase . $anioCrl . $mesCrl .$diaCrl)) {
         $dirBase = $dirBase . $anioCrl . $mesCrl . $diaCrl . "/";
         mkdir($dirBase, 0764);
      }
      else 
         $dirBase = $dirBase . $anioCrl . $mesCrl . $diaCrl . "/";
      

      if (!is_dir($dirBase . $date)) {
         mkdir($dirBase . $date, 0744);
      }

      echo "<h1>Generaci&oacute;n de CRL</h1>";

      $completDir = $dirBase . $date . "/";
      echo "<pre class='execute'>\n";
   
      $opensslCommand = "pkirisID=NULL pkirisEMAIL=NULL ".$bin['openssl']." ca -gencrl -config ".$fileVar['opensslConf']." -key $pass_phrase -out $completDir$date.pem 2>&1";
      $result = system($opensslCommand);
      if ( !$result )
         $errorCode = "a3b2c1";
      else {
         $opensslCommand2 = "pkirisID=NULL pkirisEMAIL=NULL ".$bin['openssl']." crl -inform PEM -outform DER -in $completDir$date.pem -out $completDir$date.der";
         $result2 = system($opensslCommand2);
         if ( $result2 != "") 
            $errorCode = "a3b2c2";
         else {
            $opensslCommand3 = "pkirisID=NULL pkirisEMAIL=NULL ".$bin['openssl']." crl -in $completDir$date.pem -text -out $completDir$date.txt";
            $result3 = system($opensslCommand3);
            if ( $result3 != "" ) 
               $errorCode = "a3b2c3";
            else {
               echo "</pre>\n
               <p>La generaci&oacute;n de la CRL se ha realizado con &eacute;xito.</p>
               <p>Puede encontrar los ficheros :
                <ul>
                  <li>$date.der</li>
                  <li>$date.pem</li>
                  <li>$date.txt</li>
                </ul>
                en el directorio: <br/>".$completDir."
               </p>";
               $pkiLog['status'] = "gen_crl";
               $pkiLog['eee'] = "none";
               $pkiLog['user'] = "CA-Admin";
               $pkiLog['error'] = $errorCode;
               writeLog($pkiLog);
            }
         }
      }
      break;
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   
   echo "</pre><h3>Error generando la lista de revocaci&oacute;n.</h3>";
   rmdir ($dirBase . $date);
   
   $pkiLog['status'] = "gen_crl";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "CA-Admin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();

?>
